/*
 *  ======== ti_drivers_config.h ========
 *  Configured TI-Drivers module declarations
 *
 *  The macros defines herein are intended for use by applications which
 *  directly include this header. These macros should NOT be hard coded or
 *  copied into library source code.
 *
 *  Symbols declared as const are intended for use with libraries.
 *  Library source code must extern the correct symbol--which is resolved
 *  when the application is linked.
 *
 *  DO NOT EDIT - This file is generated for the CC1352R1_LAUNCHXL
 *  by the SysConfig tool.
 */
#ifndef ti_drivers_config_h
#define ti_drivers_config_h

#define CONFIG_SYSCONFIG_PREVIEW

#define CONFIG_CC1352R1_LAUNCHXL
#ifndef DeviceFamily_CC13X2
#define DeviceFamily_CC13X2
#endif

#include <ti/devices/DeviceFamily.h>

#include <stdint.h>

/* support C++ sources */
#ifdef __cplusplus
extern "C" {
#endif


/*
 *  ======== CCFG ========
 */


/*
 *  ======== ADC ========
 */

/* DIO29 */
extern const uint_least8_t              CONFIG_ADC_0_CONST;
#define CONFIG_ADC_0                    0
#define CONFIG_TI_DRIVERS_ADC_COUNT     1


/*
 *  ======== GPIO ========
 */

/* DIO22 */
extern const uint_least8_t              CONFIG_GPIO_KEY2_CONST;
#define CONFIG_GPIO_KEY2                0
/* DIO24 */
extern const uint_least8_t              CONFIG_GPIO_KEY1_CONST;
#define CONFIG_GPIO_KEY1                1
/* DIO21 */
extern const uint_least8_t              CONFIG_GPIO_HOST_ON_CONST;
#define CONFIG_GPIO_HOST_ON             2
/* DIO28 */
extern const uint_least8_t              CONFIG_GPIO_VBAT_MEAS_CONST;
#define CONFIG_GPIO_VBAT_MEAS           3
/* DIO7 */
extern const uint_least8_t              CONFIG_GPIO_PIR_INPUT1_CONST;
#define CONFIG_GPIO_PIR_INPUT1          4
/* DIO6 */
extern const uint_least8_t              CONFIG_GPIO_PIR_INPUT2_CONST;
#define CONFIG_GPIO_PIR_INPUT2          5
/* DIO20 */
extern const uint_least8_t              CONFIG_GPIO_WIFI_CONFIG_CONST;
#define CONFIG_GPIO_WIFI_CONFIG         6
/* DIO19 */
extern const uint_least8_t              CONFIG_GPIO_WIFI_nRESET_CONST;
#define CONFIG_GPIO_WIFI_nRESET         7
#define CONFIG_TI_DRIVERS_GPIO_COUNT    8

/* LEDs are active high */
#define CONFIG_GPIO_LED_ON  (1)
#define CONFIG_GPIO_LED_OFF (0)

#define CONFIG_LED_ON  (CONFIG_GPIO_LED_ON)
#define CONFIG_LED_OFF (CONFIG_GPIO_LED_OFF)


/*
 *  ======== PIN ========
 */
#include <ti/drivers/PIN.h>

extern const PIN_Config BoardGpioInitTable[];

/* Parent Signal: CONFIG_ADC_0 ADC Pin, (DIO29) */
#define CONFIG_PIN_8                   0x0000001d
/* Parent Signal: CONFIG_GPIO_KEY2 GPIO Pin, (DIO22) */
#define CONFIG_PIN_0                   0x00000016
/* Parent Signal: CONFIG_GPIO_KEY1 GPIO Pin, (DIO24) */
#define CONFIG_PIN_1                   0x00000018
/* Parent Signal: CONFIG_GPIO_HOST_ON GPIO Pin, (DIO21) */
#define CONFIG_PIN_7                   0x00000015
/* Parent Signal: CONFIG_GPIO_VBAT_MEAS GPIO Pin, (DIO28) */
#define CONFIG_PIN_10                   0x0000001c
/* Parent Signal: CONFIG_GPIO_PIR_INPUT1 GPIO Pin, (DIO7) */
#define CONFIG_PIN_4                   0x00000007
/* Parent Signal: CONFIG_GPIO_PIR_INPUT2 GPIO Pin, (DIO6) */
#define CONFIG_PIN_5                   0x00000006
/* Parent Signal: CONFIG_GPIO_WIFI_CONFIG GPIO Pin, (DIO20) */
#define CONFIG_PIN_6                   0x00000014
/* Parent Signal: CONFIG_GPIO_WIFI_nRESET GPIO Pin, (DIO19) */
#define CONFIG_PIN_11                   0x00000013
/* XDS110 UART, Parent Signal: CONFIG_UART2_0 TX, (DIO13) */
#define CONFIG_PIN_2                   0x0000000d
/* XDS110 UART, Parent Signal: CONFIG_UART2_0 RX, (DIO12) */
#define CONFIG_PIN_3                   0x0000000c
#define CONFIG_TI_DRIVERS_PIN_COUNT    11




/*
 *  ======== UART2 ========
 */

/*
 *  TX: DIO13
 *  RX: DIO12
 *  XDS110 UART
 */
extern const uint_least8_t                  CONFIG_UART2_0_CONST;
#define CONFIG_UART2_0                      0
#define CONFIG_TI_DRIVERS_UART2_COUNT       1


/*
 *  ======== Board_init ========
 *  Perform all required TI-Drivers initialization
 *
 *  This function should be called once at a point before any use of
 *  TI-Drivers.
 */
extern void Board_init(void);

/*
 *  ======== Board_initGeneral ========
 *  (deprecated)
 *
 *  Board_initGeneral() is defined purely for backward compatibility.
 *
 *  All new code should use Board_init() to do any required TI-Drivers
 *  initialization _and_ use <Driver>_init() for only where specific drivers
 *  are explicitly referenced by the application.  <Driver>_init() functions
 *  are idempotent.
 */
#define Board_initGeneral Board_init

#ifdef __cplusplus
}
#endif

#endif /* include guard */
