/******************************************************************************
*  Filename:       event_handler.h
*  Revised:        $ $
*  Revision:       $ $
*
*  Description:    Help functions for main application event handling
*
*  Copyright (C) 2020 Texas Instruments Incorporated - http://www.ti.com/
*
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

#ifndef EVENT_HANDLER_H
#define EVENT_HANDLER_H

/* TI-RTOS Kernel modules */
#include <ti/sysbios/BIOS.h>
#include <ti/sysbios/knl/Event.h>

/* Events in use */
#define EVENT_TURN_ON_SYSTEM        (Event_Id_00)
#define EVENT_TURN_OFF_SYSTEM       (Event_Id_01)
#define EVENT_UPDATE_BATTERY_LEVEL  (Event_Id_02)
#define EVENT_WPS_BUTTON_PRESSED    (Event_Id_03)

#define EVENT_ALL (EVENT_TURN_ON_SYSTEM         | \
                   EVENT_TURN_OFF_SYSTEM        | \
                   EVENT_UPDATE_BATTERY_LEVEL   | \
                   EVENT_WPS_BUTTON_PRESSED)

/* Global event handle */
extern Event_Handle eventHandle;

#endif
