/******************************************************************************
*  Filename:       uart_command_ids.h
*  Revised:        $ $
*  Revision:       $ $
*
*  Description:    Command IDs used by this design/demo together with the UART interface
*
*  Copyright (C) 2020 Texas Instruments Incorporated - http://www.ti.com/
*
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

#ifndef UART_CMD_IDS_H
#define UART_CMD_IDS_H

/* A device sending a PING can expect a zero-payload PONG in responds. */
#define UART_IC_PING (0x0)
#define UART_IC_PONG (0x1)

/* The dvice equesting system powerdown can expect a zero-payload responds as a confirmation */
#define UART_IC_TURN_OF_SYSTEM_REQUEST (0x2)
#define UART_IC_TURN_OF_SYSTEM_REQUEST_RSP (0x3)

/* The device requesting for the latest battery status can expect a responds with a 2-byte payload as a confirmation */
#define UART_IC_GET_BATTERY_STATUS (0x4)
#define UART_IC_GET_BATTERY_STATUS_RSP (0x5)

/* The device requesting the latest battery status can expect a responds with a 2-byte payload as a confirmation */
#define UART_IC_GET_BATTERY_STATUS (0x4)
#define UART_IC_GET_BATTERY_STATUS_RSP (0x5)

/* The device issuing the WPS button even can expect a zero-payload responds as a confirmation  */
#define UART_IC_EV_WPS_BUTTON_PRESSED (0x6)
#define UART_IC_EV_WPS_BUTTON_PRESSED_RSP (0x7)

#endif
